#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/trie_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long

int binpow(int n, int p) {
    if (p == 0) {
        return 1;
    }
    if (p % 2 == 0) {
        int x = binpow(n, p / 2);
        return x * x;
    }
    return binpow(n, p - 1) * n;
}

int main() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    vector<int> primes;
    vector<int> used(1e6, false);
    used[0] = 1;
    for (int i = 2; i <= 1e6; i++) {
        if (!used[i]) {
            primes.push_back(i);
        }
        for (auto j: primes) {
            if (i * j >= 1e6) {
                break;
            }
            used[i * j] = 1;
        }
    }
    vector<int> otv(n);
    for (int i = 0; i < n; i++) {
        int x = a[i];
        int c = 0;
        for (auto j: primes) {
            if (j > x) {
                break;
            }
            if (x % j != 0) continue;
            int l = 0, r = __lg(x) / __lg(j) + 1;
            while (r - l > 1) {
                int m = (r + l) / 2;
                if (x % binpow(j, m) == 0) {
                    l = m;
                } else {
                    r = m;
                }
            }
            x /= binpow(j, l);
            c += l;
        }
        otv[i] = 1 + (c % 2 == 0);
    }
    for (auto i: otv) {
        cout << i << ' ';
    }
}
