#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/trie_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long

int binpow(int n, int p) {
    if (p == 0) {
        return 1;
    }
    if (p % 2 == 0) {
        int x = binpow(n, p / 2);
        return x * x;
    }
    return binpow(n, p - 1) * n;
}

signed main() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    vector<int> primes;
    vector<int> used(1e6, -1);
    used[0] = -1;
    used[1] = 1;
    for (int i = 2; i <= 1e6; i++) {
        if (used[i] == -1) {
            used[i] = i;
            primes.push_back(i);
        }
        for (auto j: primes) {
            if (i * j >= 1e6) {
                break;
            }
            used[i * j] = j;
        }
    }
    vector<int> otv(n);
    for (int i = 0; i < n; i++) {
        int x = a[i];
        int c = 0;
        while (x != 1) {
            x /= used[x];
            c++;
        }
        otv[i] = 1 + (c % 2 == 0);
    }
    for (auto i: otv) {
        cout << i << ' ';
    }
}
