#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/trie_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long

int n, m;
vector<int> a;

void solve3() {
    map<int, int> x;
    for (int i = 0; i < n; i++) {
        x[a[i]]++;
    }
    if (x[1] % 3 == x[2] % 3 && x[2] % 3 == x[3] % 3) {
        map<vector<int>, int> dp;
        map<vector<int>, int> used;
        dp[{x[1], x[2], x[3]}] = 1;
        used[{x[1], x[2], x[3]}] = 1;
        queue<vector<int>> q;
        q.push({x[1], x[2], x[3]});
        while (!q.empty()) {
            vector<int> now = q.front();
            q.pop();
            if (now[0] >= 3 && now[1] >= 3 && now[2] >= 3) {
                if (!used[{now[0] - 3, now[1] - 3, now[2] - 3}]) {
                    used[{now[0] - 3, now[1] - 3, now[2] - 3}] = true;
                    q.push({now[0] - 3, now[1] - 3, now[2] - 3});
                }
                dp[{now[0] - 3, now[1] - 3, now[2] - 3}] += dp[now];
            }
            if (now[0] > 0 && now[1] > 0 && now[2] > 0) {
                if (!used[{now[0] - 1, now[1] - 1, now[2] - 1}]) {
                    used[{now[0] - 1, now[1] - 1, now[2] - 1}] = true;
                    q.push({now[0] - 1, now[1] - 1, now[2] - 1});
                }
                dp[{now[0] - 1, now[1] - 1, now[2] - 1}] += dp[now];
            }
        }
        cout << dp[{0, 0, 0}] << '\n';
    } else {
        cout << 0;
    }
    exit(0);
}

signed main() {
    cin >> n >> m;
    a.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    if (m <= 3) {
        solve3();
    }
}
