#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

void answer(long long mask1, long long mask2) {
    cout << "YES\n";
    int c = 0;
    for (int i = 0; i < 16; i++) {
        if (mask2 & (1 << i)) {
            c++;
        }
    }
    for (int i = 0; i < 16; i++) {
        if (mask1 & (1 << i)) {
            c++;
        }
    }
    cout << c << '\n';
    for (int i = 0; i < 16; i++) {
        if (mask2 & (1 << i)) {
            cout << "1 " << i + 1 << '\n';
        }
    }
    for (int i = 0; i < 16; i++) {
        if (mask1 & (1 << i)) {
            cout << "2 " << i + 1 << '\n';
        }
    }
    exit(0);
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, m;
    cin >> n >> m;
    vector<vector<int>> h(n, vector<int>(m));
    vector<vector<int>> w(m, vector<int>(n));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            int x;
            cin >> x;
            h[i][j] = x;
            w[j][i] = x;
        }
    }
    vector<vector<long long>> hvert(n, vector<long long>(1 << m, 0));
    for (long long i = 0; i < n; i++) {
        for (long long mask = 0; mask < (1 << m); mask++) {
            for (long long j = 0; j < m; j++) {
                if (!(mask & (1 << j))) {
                    hvert[i][mask] += h[i][j];
                }
            }
        }
    }
    vector<vector<long long>> whor(m, vector<long long>(1 << n, 0));
    for (long long i = 0; i < m; i++) {
        for (long long mask = 0; mask < (1 << n); mask++) {
            for (long long j = 0; j < n; j++) {
                if (!(mask & (1 << j))) {
                    whor[i][mask] += w[i][j];
                }
            }
        }
    }
    long long s = 0;
    cin >> s;
    gp_hash_table<long long, long long> ans;
    gp_hash_table<long long, long long> upd;
    for (long long mask1 = 0; mask1 < (1 << m); mask1++) {
        long long sum = 0;
        for (int i = 0; i < n; i++) {
            sum += hvert[i][mask1];
        }
        if (sum < s) {
            continue;
        }
        if (n <= 8) {
            for (long long mask2 = 0; mask2 < (1 << n); mask2++) {
                long long tmp = sum;
                for (int i = 0; i < m; i++) {
                    if (!(mask1 & (1 << i))) {
                        sum -= whor[i][0] - whor[i][mask2];
                    }
                }
                if (sum == s) {
                    answer(mask1, mask2);
                }
                sum = tmp;
            }
        } else {
            vector<int> use;
            for (int i = 0; i < m; i++) {
                if (!(mask1 & (1 << i))) {
                    use.push_back(i);
                }
            }
            for (long long mask2 = 0; mask2 < (1 << 8); mask2++) {
                long long now = 0;
                for (auto i: use) {
                    now += whor[i][0] - whor[i][mask2];
                }
                upd[s - (sum - now)] = mask1;
                ans[s - (sum - now)] = mask2;
            }
            int tn = n - 8;
            for (long long mask2 = 0; mask2 < (1 << tn); mask2++) {
                long long now = 0;
                for (auto i: use) {
                    now += whor[i][0] - whor[i][mask2 << 8];
                }
                if (ans.count(-1 * now) != 0 && upd[-1 * now] == mask1) {
                    answer(mask1, ans[-1 * now] + (mask2 << 8));
                }
            }
        }
    }
    cout << "NO\n";
}
