#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

int n, k, t;
vector<vector<int>> g;
vector<int> dist;
vector<int> dp;
vector<int> p;

void dfs(int v) {
    for (auto u: g[v]) {
        if (dist[u] == 1e9) {
            dist[u] = dist[v] + 1;
            dp[u] = dist[v] + 1;
            p[u] = v;
            dfs(u);
        }
    }
    for (auto u: g[v]) {
        if (u != p[v]) {
            dp[v] = max(dp[v], dp[u]);
        }
    }
}

vector<int> up;

void ups(int v) {
    int m1 = -1, m2 = -1;
    for (auto u: g[v]) {
        if (u != p[v]) {
            if (m1 == -1 || dp[m1] < dp[u]) {
                m2 = m1;
                m1 = u;
            } else if (m2 == -1 || dp[m2] < dp[u]) {
                m2 = u;
            }
        }
    }
    if (g[v].size() == 1) {
        return;
    }
    for (auto u: g[v]) {
        if (u != p[v] && up[u] == -1) {
            up[u] = up[v];
            if (m2 != -1) {
                up[u] = max(up[v], dp[(m1 == u ? m2 : m1)]);
            }
            ups(u);
        }
    }
}

void solve() {
    dist.resize(n, 1e9);
    dp.resize(n, -1);
    up.resize(n, -1);
    p.resize(n, -1);
    dist[0] = 0;
    dfs(0);
    ups(0);
    int otv = 1e9;
    for (int i = 0; i < n; i++) {
        otv = min(otv, max(dp[i] - dist[i] + 1, up[i]));
    }
    cout << otv;
    exit(0);
}

signed main() {
    cin >> n >> k >> t;
    g.resize(n);
    for (int i = 0; i < n - 1; i++) {
        int a, b;
        cin >> a >> b;
        --a;
        --b;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    if (k == 1 && t == 0) {
        solve();
    }
    if (t == 0) {
        int otv = 1e8;
        for (int j = 0; j <= k; j++) {
            otv = min(otv, max((n - 1 + j) / (j + 1), (k - j) / (k - j + 1)));
        }
        cout << otv << ' ';
//        cout << (n - 1 + k) / (k + 1);
    } else {
        for (int i = 0; i < n; i++) {
            int otv = 1e8;
            for (int j = 0; j <= k; j++) {
                otv = min(otv, max((n - 1 - i + j) / (j + 1), (i + k - j) / (k - j + 1)));
            }
            cout << otv << ' ';
        }
    }
}
