#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/trie_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

int main() {
    int n;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    vector<int> primes;
    vector<int> used(1e6, false);
    used[0] = 1;
    for (int i = 2; i <= 1e6; i++) {
        if (!used[i]) {
            primes.push_back(i);
        }
        for (auto j: primes) {
            if (i * j >= 1e6) {
                break;
            }
            used[i * j] = 1;
        }
    }
    vector<int> otv(n);
    for (int i = 0; i < n; i++) {
        int x = a[i];
        int c = 0;
        for (auto j: primes) {
            if (j > x) {
                break;
            }
            while (x % j == 0) {
                x /= j;
                c++;
            }
        }
        otv[i] = 1 + (c % 2 == 0);
    }
    for (auto i: otv) {
        cout << i << ' ';
    }
}
