#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/trie_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long

int mod = 1e9 + 7;
int C[5001][5001];

void build() {
    for (int i = 0; i <= 5000; i++) {
        for (int j = 0; j <= 5000; j++) {
            if (i == 0 || j == 0 || i == j) {
                C[i][j] = 1;
                continue;
            }
            if (i < j) {
                C[i][j] = (C[i][j - 1] + C[i - 1][j - 1]) % mod;
            } else {
                C[i][j] = (C[i - 1][j] + C[i - 1][j - 1]) % mod;
            }
        }
    }
}

int count(int n) {
    int otv = 1;
    for (int k = 1; k <= n / 3; k++) {
        otv += C[k][n - 3 * k + k];
        otv %= mod;
    }
    return otv;
}

int n, m;
vector<int> a;


void solve3() {
    map<int, int> x;
    for (int i = 0; i < n; i++) {
        x[a[i]]++;
    }
    int otv = 0;
    for (int k1 = 0; k1 <= n; k1++) {
        for (int k2 = 0; k2 <= n; k2++) {
            if ((x[1] - 3 * k1) % 3 != 0 || x[1] - 3 * k1 < 0)
                break;
            if ((x[2] - 3 * (k1 + k2)) % 3 != 0 || x[2] - 3 * (k1 + k2) < 0) {
                continue;
            }
            if ((x[3] - 3 * (k1 + k2)) % 3 != 0 || x[3] - 3 * (k1 + k2) < 0)
                continue;
            if ((x[4] - 3 * k2) % 3 != 0 || x[4] - 3 * k2 < 0) {
                continue;
            }
            otv++;
        }
    }
    cout << otv;
}

signed main() {
    build();
    cin >> n >> m;
    a.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    if (m <= 4) {
        solve3();
    }
}
