#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/trie_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long

int solve4(vector<int> a, int n) {
    map<int, int> x;
    for (int i = 0; i < n; i++) {
        x[a[i]]++;
    }
    int otv = 0;
    for (int k1 = 0; k1 <= n; k1++) {
        for (int k2 = 0; k2 <= n; k2++) {
            if ((x[1] - k1) % 3 != 0 || x[1] - k1 < 0)
                continue;
            if ((x[2] - (k1 + k2)) % 3 != 0 || x[2] - (k1 + k2) < 0) {
                continue;
            }
            if ((x[3] - (k1 + k2)) % 3 != 0 || x[3] - (k1 + k2) < 0)
                continue;
            if ((x[4] - k2) % 3 != 0 || x[4] - k2 < 0) {
                continue;
            }
            otv++;
        }
    }
    return otv;
}

int solve3(vector<int> a, int n) {
    map<int, int> x;
    for (int i = 0; i < n; i++) {
        x[a[i]]++;
    }
    if (x[1] % 3 == x[2] % 3 && x[2] % 3 == x[3] % 3) {
        int otv = 0;
        for (int k = 0; k <= n; k++) {
            bool ok = true;
            for (int i = 1; i <= 3; i++) {
                if (x[i] - k < 0 || (x[i] - k) % 3 != 0) {
                    ok = false;
                }
            }
            otv += ok;
        }
        return otv;
    } else {
        return 0;
    }
}

void solve_malo(map<int, int> x, int n, int m) {
    for (int i = 1; i <= m; i++) {
        if (x[i] % 3 == 0) continue;
        int p = x[i] % 3;
        if (x[i + 1] - p < 0 || x[i + 2] - p < 0) {
            cout << 0;
            exit(0);
        } else {
            x[i] -= p;
            x[i + 1] -= p;
            x[i + 2] -= p;
        }
    }
    cout << 1;
    exit(0);
}

int n, m;
vector<int> a;

signed main() {
    cin >> n >> m;
    a.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    if (m <= 4) {
        cout << solve4(a, n);
        exit(0);
    }
    map<int, int> x;
    int mas = 0;
    for (int i = 0; i < n; i++) {
        x[a[i]]++;
        mas = max(mas, x[a[i]]);
    }
    if (mas <= 2) {
        solve_malo(x, n, m);
    }
}
