#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/trie_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long

vector<pair<int, int>> g;
vector<vector<int>> d;
vector<int> t, p;

vector<int> operator+(vector<int> a, vector<int> b) {
    int l = 0, r = 0;
    vector<int> otv;
    while (l < a.size() && r < b.size()) {
        if (a[l] < b[r]) {
            otv.push_back(a[l]);
            l++;
        } else {
            otv.push_back(b[r]);
            r++;
        }
    }
    while (l < a.size()) {
        otv.push_back(a[l]);
        l++;
    }
    while (r < b.size()) {
        otv.push_back(b[r]);
        r++;
    }
    return otv;
}

void build(int v) {
    if (v == -1) return;
    if (g[v].first == g[v].second && g[v].first == -1) {
        d[v] = {v};
        return;
    }
    build(g[v].first);
    build(g[v].second);
    d[v] = {v};
    if (g[v].first != -1) {
        d[v] = d[g[v].first] + d[v];
    }
    if (g[v].second != -1) {
        d[v] = d[g[v].second] + d[v];
    }
}

void push(int v) {
    if (p[v] != 10) {
        t[v * 2 + 1] = p[v];
        t[v * 2 + 2] = p[v];
        p[v * 2 + 1] = p[v];
        p[v * 2 + 2] = p[v];
    }
    p[v] = 10;
}

void setx(int v, int tl, int tr, int l, int r, int x) {
    if (l <= tl && tr <= r) {
        t[v] = x;
        p[v] = x;
        return;
    }
    if (tr <= l || r <= tl) {
        return;
    }
    push(v);
    int m = (tl + tr) / 2;
    setx(v * 2 + 1, tl, m, l, r, x);
    setx(v * 2 + 2, m, tr, l, r, x);
    t[v] = min(t[v * 2 + 1], t[v * 2 + 2]);
}

int getx(int v, int l, int r, int pos) {
    if (r - l == 1) {
        return t[v];
    }
    push(v);
    int m = (r + l) / 2;
    if (pos < m) {
        return getx(v * 2 + 1, l, m, pos);
    } else {
        return getx(v * 2 + 2, m, r, pos);
    }
}

int n;

int getp(int v, int x) {
    if (v == x) {
        int s = getx(0, 0, n, v);
        return 1 + (s > -1) * d[g[v].first].size() + (s > 0) * d[g[v].second].size();
    }
    if (*--upper_bound(d[g[v].first].begin(), d[g[v].first].end(), x) == x) {
        return getp(g[v].first, x) + (getx(0, 0, n, v) == -1);
    } else {
        return (int) d[g[v].first].size() + getp(g[v].second, x) + (getx(0, 0, n, v) != 1);
    }
}

signed main() {
    int q;
    cin >> n >> q;
    int tn = 1;
    while (tn <= n) { tn *= 2; }
    g.resize(tn);
    d.resize(tn);
    t.resize(4 * tn, -1);
    p.resize(4 * tn, 10);
    for (int i = 0; i < n; i++) {
        int l, r;
        cin >> l >> r;
        g[i] = {--l, --r};
    }
    build(0);
    while (q--) {
        int type;
        cin >> type;
        if (type == 2) {
            int x;
            cin >> x;
            cout << getp(0, --x) << '\n';
        } else {
            int l, r, x;
            cin >> l >> r >> x;
            --l;
            setx(0, 0, n, l, r, x);
        }
    }
}

